;;;-*- Mode: Lisp; Syntax: Common-Lisp; Base: 10; Package: join-label-context -*-
#|
-----------------------------------------------------------------------------------
TITLE: 
-----------------------------------------------------------------------------------
File:    join-label-context.em
Version: 1.7 (last modification on Mon Jan 17 16:00:11 1994)
State:   published

DESCRIPTION:
DOCUMENTATION:
NOTES:
REQUIRES:
PROBLEMS:
AUTHOR: Dr. Horst Firedrich
CONTACT: horst.friedrich@isst.fhg.de
HISTORY: 
Log for /export/home/saturn/ukriegel/Dist/Apply/join-label-context.em[1.7]:
  text
[1.1] Thu Mar 18 09:00:42 1993 hfried@isst proposed
  [Fri Mar  5 13:04:19 1993] Intention for change:
[1.2] Wed Mar 24 13:49:14 1993 hfried@isst proposed
  [Thu Mar 18 09:12:27 1993] Intention for change:
  + glob anna
[1.3] Thu Mar 25 11:20:20 1993 hfried@isst proposed
  [Wed Mar 24 14:54:18 1993] Intention for change:
  + gen-fun
  new head
[1.4] Tue Apr 13 14:09:56 1993 hfried@isst proposed
  [Thu Mar 25 11:54:28 1993] Intention for change:
[1.5] Mon Jun 21 11:46:34 1993 hfried@isst saved
  [Tue Apr 13 14:16:04 1993] Intention for change:
[1.6] Thu Aug 26 11:48:23 1993 hfried@isst published
  [Mon Aug 23 16:02:41 1993] Intention for change:
  closure-function
[1.7] Wed Jan 19 13:06:05 1994 hfried@isst published
  [Mon Jan 17 13:03:33 1994] Intention for change:
  slot-value

-----------------------------------------------------------------------------------
|#
#module-name join-label-context
#module-import 
( level-1-eulisp
  SIMPLE-PROGRAMMING
  LZS 
  MZS 
  context 
  progn-context
  if-form
  setq-form
  letstar-form
  function-call
  lzs-to-mzs-fun
  slot-value
  gutter
  (only (error) common-lisp)
  analyse-h) ; make-vector and vector-ref
;; typeinfernce

#module-syntax-import 
( level-1-eulisp )
#module-syntax-definitions

;--- defmacro forms

#module-header-end


;  exports



;------------------------------------------------------
; constants
;------------------------------------------------------

;          -----       ------------        -------------
(defmethod l2m-a ((con <join-label>) (form <named-const>))
;          -----       ------------        -------------
;
; form = <defined-named-constant>, <imported-named-constant>
;
  form)

;          -----       ------------        -----
(defmethod l2m-a ((con <join-label>) (form <sym>))
;          -----       ------------        -----
;
; form = <defined-symbol>, <imported-symbol>
;
  form)

; symbol is a slot name and not allowed in normal functions
;;          -----       ------------        -----
;(defmethod l2m-a ((con <join-label>) (form <symbol>))
;;          -----       ------------        -----
;;
;; form = <defined-symbol>, <imported-symbol>
;;
;  form)

;          -----       ------------        ----------------
(defmethod l2m-a ((con <join-label>) (form <structured-literal>))
;          -----       ------------        ----------------
; 
; value = <vector>, <pair>, <string>, LITERAL-INSTANCE
;
  form)

;          -----       ------------        -------
(defmethod l2m-a ((con <join-label>) (form <spint>))
;          -----       ------------        -------
;
; <spint> - single precisition integer
;
  form)

;          -----       ------------        --------------
(defmethod l2m-a ((con <join-label>) (form <double-float>))
;          -----       ------------        --------------
 form)

;          -----       ------------        -----------
(defmethod l2m-a ((con <join-label>) (form <character>))
;          -----       ------------        -----------
 form)

;          -----       ------------        ----------
(defmethod l2m-a ((con <join-label>) (form <class-def>))
;          -----       ------------        -----------
;
;  form = <defined-class>, <imported-class>
;
 form)

;          -----       ------------        --------------
(defmethod l2m-a ((con <join-label>) (form <literal-instance>))
;          -----       ------------        --------------
  form)

;          -----       ------------        ------------
(defmethod l2m-a ((con <join-label>) (form <global-fun>))
;          -----       ------------        ------------
  (setf (?function-type form) $data)
  form)

;          -----       ------------        -----------
(defmethod l2m-a ((con <join-label>) (form <local-fun>))
;          -----       ------------        -----------
  (lzs2mzs-fun form)
  (if (eq (?function-type form) $closure)
    (make-a-closure-function form (dynamic block))
    form)
)

;          -----       ------------        --------------
(defmethod l2m-a ((con <join-label>) (form <imported-fun>))
;          -----       ------------        --------------
  (setf (?function-type form) $data)
  form)

;          -----       ------------        -------------
(defmethod l2m-a ((con <join-label>) (form <special-sys-fun>))
;          -----       ------------        -------------
  (setf (?function-type form) $data)
  form)

;          -----       ------------        ----------------
(defmethod l2m-a ((con <join-label>) (form <global-generic-fun>))
;          -----       ------------        ----------------
  (setf (?function-type form) $data)
  form)

;          -----       ------------        ---------------
(defmethod l2m-a ((con <join-label>) (form <local-generic-fun>))
;          -----       ------------        ---------------
  (setf (?function-type form) $data)
  form)

;          -----       ------------        ------------------
(defmethod l2m-a ((con <join-label>) (form <imported-generic-fun>))
;          -----       ------------        ------------------
  (setf (?function-type form) $data)
  form)

;          -----       ------------        ------
(defmethod l2m-a ((con <join-label>) (form <cont>))
;          -----       ------------        ------
  form)

;          -----       ------------        ------
(defmethod l2m-a ((con <join-label>) (form <null>))
;          -----       ------------        ------
  form)

;------------------------------------------------------
;   end of constans and variables, begin of special-forms
;------------------------------------------------------

;          -----       ------------        ---------
(defmethod l2m-a ((con <join-label>) (form <var-ref>))
;          -----       ------------        ---------
;
; var = <local-static>, <global-static>, <imported-static>, <dynamic>
;
  (let ((var (?var form)))
    (if (local-static-p var) (rename var)
        var))
)

;          -----       ------------        -----
(defmethod l2m-a ((con <join-label>) (form <app>))
;          -----       ------------        -----
;
; function = <global-fun>, <local-fun>, <imported-fun>, <special-sys-fun>,
; <global-generic-fun>, <local-generic-fun>, imported-generic-fun>, <var-ref>,
; <cont>, <defined-named-constant>, <imported-named-constant>
;
  (let ((fun (?function form)))
    (if (cont-p fun) (error "continuation in argument position")
        (call-a-function fun (?arg-list form) nil (?read-glocs form)))))

;          -----       -----        ----------------
(defmethod l2m-a ((con <join-label>) (form <set-slot-value>))
;          -----       -----        ----------------
  (set-slot-value-a con form))

;          -----       -----        ----------------
(defmethod l2m-a ((con <join-label>) (form <get-slot-value>))
;          -----       -----        ----------------
  (get-slot-value-a con form))

;          -----       ------------        -----------
(defmethod l2m-a ((con <join-label>) (form <setq-form>))
;          -----       ------------        -----------
;
; location = <local-static>, <global-static>, <imported-static>, <dynamic>,
; <defined-named-const>, <imported-named-const>
;
   (setq-form-a con form)
)

;          -----       ------------        ------------
(defmethod l2m-a ((con <join-label>) (form <progn-form>))
;          -----       ------------        ------------
   (l2m-progn con (?form-list form))
)

;          -----       ------------        ---------
(defmethod l2m-a ((con <join-label>) (form <if-form>))
;          -----       ------------        ---------
   (if-form-a con form))

;          -----       ------------        -------------
(defmethod l2m-a ((con <join-label>) (form <switch-form>))
;          -----       ------------        -------------
   (print "<join-label> <switch-form> not implemented") 
   ())

;          -----       ------------        -----------
(defmethod l2m-a ((con <join-label>) (form <let*-form>))
;          -----       ------------        -----------
   (letstar-a con form))

;          -----       ------------        -------------
(defmethod l2m-a ((con <join-label>) (form <labels-form>))
;          -----       ------------        -------------
   (l2m-a con (?body form))
)

;          -----       ------------        -------------
(defmethod l2m-a ((con <join-label>) (form <let/cc-form>))
;          -----       ------------        -------------
   (print "<join-label> <let/cc-form> not implemented") 
   ())

;
;(defmethod l2m-a ((con <join-label>) (form <labeled-form>))
;   (print "<join-label> <labeled-form> not implemented") 
;   ())
;
;
;(defmethod l2m-a ((con <join-label>) (form <tagbody-form>))
;   (print "<join-label> <tagbody-form> not implemented") 
;   ())
;
;
;(defmethod l2m-a ((con <join-label>) (form <mv-lambda>))
;   (print "<join-label> <mv-lambda> not implemented") 
;   ())
;

#module-end