;;;-*- Mode: Lisp; Syntax: Common-Lisp; Base: 10; Package: switch-context -*-
#|
-----------------------------------------------------------------------------------
TITLE: 
-----------------------------------------------------------------------------------
File:    switch-context.em
Version: 1.6 (last modification on Mon Jan 17 16:01:20 1994)
State:   published

DESCRIPTION:
DOCUMENTATION:
NOTES:
REQUIRES:
PROBLEMS:
AUTHOR: Dr. Horst Firedrich
CONTACT: horst.friedrich@isst.fhg.de
HISTORY: 
Log for /export/home/saturn/ukriegel/Dist/Apply/switch-context.em[1.6]:
  text
[1.1] Thu Mar 18 09:02:04 1993 hfried@isst proposed
  [Fri Mar  5 13:05:37 1993] Intention for change:
[1.2] Wed Mar 24 13:50:47 1993 hfried@isst proposed
  [Thu Mar 18 09:14:00 1993] Intention for change:
[1.3] Thu Mar 25 11:22:20 1993 hfried@isst proposed
  [Wed Mar 24 14:55:59 1993] Intention for change:
  + gen-fun
  new head
[1.4] Tue Apr 13 14:11:37 1993 hfried@isst proposed
  [Thu Mar 25 11:55:26 1993] Intention for change:
[1.5] Mon Jun 21 11:50:08 1993 hfried@isst published
  [Tue Apr 13 14:17:21 1993] Intention for change:
[1.6] Wed Jan 19 13:06:48 1994 hfried@isst published
  [Mon Jan 17 13:04:37 1994] Intention for change:
  slot-value

-----------------------------------------------------------------------------------
|#

#module-name switch-context
#module-import 
( level-0-eulisp
  level-1-eulisp
  SIMPLE-PROGRAMMING
  LZS 
  MZS 
  context
  progn-context
  slot-value
  analyse-h) ; make-vector and vector-ref
;; typeinfernce

#module-syntax-import 
( level-0-eulisp
  level-1-eulisp )
#module-syntax-definitions

;--- defmacro forms

#module-header-end


;  exports



;--------------------------------------
; constants
;--------------------------------------

;          -----       --------        -------------
(defmethod l2m-a ((con <switch>) (form <named-const>))
;          -----       --------        -------------
;
; form = <defined-named-constant>, <imported-named-constant>
;
   (print "<switch> <named-const> not implemented") 
   ())

;          -----       --------        -----
(defmethod l2m-a ((con <switch>) (form <sym>))
;          -----       --------        -----
;
; form = <defined-symbol>, <imported-symbol>
;
   (print "<switch> <sym> not implemented") 
   ())

; symbol is a slot name and not allowed in normal functions

;          -----       --------        ------------
(defmethod l2m-a ((con <switch>) (form <structured-literal>))
;          -----       --------        ------------
; 
; value = <vector>, <pair>, <string>, LITERAL-INSTANCE
;
   (print "<switch> <structured-literal> not implemented") 
   ())

;          -----       --------        -------
(defmethod l2m-a ((con <switch>) (form <spint>))
;          -----       --------        -------
;
; <spint> - single precisition integer
;
   (print "<switch> <class-def> not implemented") 
   ())

;          -----       --------        --------------
(defmethod l2m-a ((con <switch>) (form <double-float>))
;          -----       --------        --------------
   (print "<switch> <double-float> not implemented") 
   ())

;          -----       --------        -----------
(defmethod l2m-a ((con <switch>) (form <character>))
;          -----       --------        -----------
   (print "<switch> <character> not implemented") 
   ())

;          -----       --------        ----------
(defmethod l2m-a ((con <switch>) (form <class-def>))
;          -----       --------        -----------
;
;  form = <defined-class>, <imported-class>
;
   (print "<switch> <class-def> not implemented") 
   ())

;          -----       --------        ----------
(defmethod l2m-a ((con <switch>) (form <literal-instance>))
;          -----       --------        ----------
   (print "<switch> <literal-instance> not implemented") 
   ())

;          -----       --------        ------------
(defmethod l2m-a ((con <switch>) (form <global-fun>))
;          -----       --------        ------------
   (print "<switch> <global-fun> not implemented") 
   ())

;          -----       --------        -----------
(defmethod l2m-a ((con <switch>) (form <local-fun>))
;          -----       --------        -----------
   (print "<switch> <local-fun> not implemented") 
   ())

;          -----       --------        --------------
(defmethod l2m-a ((con <switch>) (form <imported-fun>))
;          -----       --------        --------------
   (print "<switch> <imported-fun> not implemented") 
   ())

;          -----       --------        ---------
(defmethod l2m-a ((con <switch>) (form <special-sys-fun>))
;          -----       --------        ---------
   (print "<switch> <special-sys-fun> not implemented") 
   ())

;          -----       --------        ------------
(defmethod l2m-a ((con <switch>) (form <global-generic-fun>))
;          -----       --------        ------------
   (print "<switch> <global-generic-fun> not implemented") 
   ())

;          -----       --------        -----------
(defmethod l2m-a ((con <switch>) (form <local-generic-fun>))
;          -----       --------        -----------
   (print "<switch> <local-generic-fun> not implemented") 
   ())

;          -----       --------        --------------
(defmethod l2m-a ((con <switch>) (form <imported-generic-fun>))
;          -----       --------        --------------
   (print "<switch> <imported-generic-fun> not implemented") 
   ())

;          -----       --------        ------
(defmethod l2m-a ((con <switch>) (form <cont>))
;          -----       --------        ------
   (print "<switch> <cont> not implemented") 
   ())

;          -----       --------        ------
(defmethod l2m-a ((con <switch>) (form <null>))
;          -----       --------        ------
   (print "<switch> <null> not implemented") 
   ())

;--------------------------------------
;   end of constans and variables, begin of special-forms
;--------------------------------------

;          -----       --------        ---------
(defmethod l2m-a ((con <switch>) (form <var-ref>))
;          -----       --------        ---------
;
; var = <local-static>, <global-static>, <imported-static>, <dynamic>
;
   (print "<switch> <var-ref> not implemented") 
   ())

;          -----       --------        -----
(defmethod l2m-a ((con <switch>) (form <app>))
;          -----       --------        -----
;
; function = <global-fun>, <local-fun>, <imported-fun>, <special-sys-fun>,
; <global-generic-fun>, <local-generic-fun>, imported-generic-fun>, <var-ref>,
; <cont>, <defined-named-constant>, <imported-named-constant>
;
   (print "<switch> <app> not implemented") 
   ())

;          -----       -----        ----------------
(defmethod l2m-a ((con <switch>) (form <set-slot-value>))
;          -----       -----        ----------------
   (print "<switch> <set-slot-value> not implemented") 
   ())

;          -----       -----        ----------------
(defmethod l2m-a ((con <switch>) (form <get-slot-value>))
;          -----       -----        ----------------
   (print "<switch> <get-slot-value> not implemented") 
   ())

;          -----       --------        -----------
(defmethod l2m-a ((con <switch>) (form <setq-form>))
;          -----       --------        -----------
;
; location = <local-static>, <global-static>, <imported-static>, <dynamic>,
; <defined-named-const>, <imported-named-const>
;
   (print "<switch> <setq-form> not implemented") 
   ())

;          -----       --------        ------------
(defmethod l2m-a ((con <switch>) (form <progn-form>))
;          -----       --------        ------------
   (l2m-progn con (?form-list form)))

;          -----       --------        ---------
(defmethod l2m-a ((con <switch>) (form <if-form>))
;          -----       --------        ---------
   (print "<switch> <if-form> not implemented") 
   ())

;          -----       --------        -------------
(defmethod l2m-a ((con <switch>) (form <switch-form>))
;          -----       --------        -------------
   (print "<switch> <switch-form> not implemented") 
   ())

;          -----       --------        -----------
(defmethod l2m-a ((con <switch>) (form <let*-form>))
;          -----       --------        -----------
   (print "<switch> <let*-form> not implemented") 
   ())

;          -----       --------        -------------
(defmethod l2m-a ((con <switch>) (form <labels-form>))
;          -----       --------        -------------
   (print "<switch> <labels-form> not implemented") 
   ())

;          -----       --------        -------------
(defmethod l2m-a ((con <switch>) (form <let/cc-form>))
;          -----       --------        -------------
   (print "<switch> <let/cc-form> not implemented") 
   ())

;
;(defmethod l2m-a ((con <switch>) (form <labeled-form>))
;   (print "<switch> <labeled-form> not implemented") 
;   ())
;
;
;(defmethod l2m-a ((con <switch>) (form <tagbody-form>))
;   (print "<switch> <tagbody-form> not implemented") 
;   ())
;
;
;(defmethod l2m-a ((con <switch>) (form <mv-lambda>))
;   (print "<switch> <mv-lambda> not implemented") 
;   ())
;

#module-end